searchNodes=[{"doc":"A keyset pagination library for Ecto queries Keyset pagination works by filtering a data set with Ecto.Query.where/3 s rather than Ecto.Query.offset/3 . Fob requires that any queryables are ordered by a unique column as the last ordering condition. Other non-unique columns may be ordered by as well, but the last Ecto.Query.order_by/3 must be unique.","ref":"Fob.html","title":"Fob","type":"module"},{"doc":"Limits a queryable to return records between two page break boundaries","ref":"Fob.html#between_bounds/3","title":"Fob.between_bounds/3","type":"function"},{"doc":"Limits an Ecto.Queryable to the next page of data page_breaks are used to add Ecto.Query.where/3 filters to the query which limit the query to the next page. page_size translates to a Ecto.Query.limit/2 .","ref":"Fob.html#next_page/3","title":"Fob.next_page/3","type":"function"},{"doc":"Returns the page breaks for a record The query does not need to be limited by next_page/3 or between_bounds/3 : the query only needs to have the Ecto.Query.order_by/3 s used in the query to get the record. Examples iex&gt; records = MyApp.Repo . all ( Fob . next_page ( query , current_page_breaks , page_size ) ) iex&gt; next_page_breaks = Fob . page_breaks ( query , List . last ( records ) )","ref":"Fob.html#page_breaks/2","title":"Fob.page_breaks/2","type":"function"},{"doc":"A cursor data structure that can be used to fetch the next pages The cursor data structure is somewhat similar to a Stream except that it cannot wrap a stateful process and does not require any life-cycle hooks. The next pages of data can be fetched by calling next/1 successively, passing in the updated t/0 data structure each time. Examples iex&gt; import Ecto.Query , only : [ order_by : 2 ] iex&gt; cursor = Fob.Cursor . new ( order_by ( MyApp.Schema , asc : :id ) , MyApp.Repo , nil , 3 ) # Fob.Cursor &lt; ... &gt; iex&gt; { _records , cursor } = Fob.Cursor . next ( cursor ) { [ %{ id : 1 } , %{ id : 2 } , %{ id : 3 } ] , # Fob.Cursor &lt; ... &gt; } iex&gt; { _records , cursor } = Fob.Cursor . next ( cursor ) { [ %{ id : 4 } , %{ id : 5 } , %{ id : 6 } ] , # Fob.Cursor &lt; ... &gt; } iex&gt; { _records , cursor } = Fob.Cursor . split ( cursor , 2 ) { [ %{ id : 7 } , %{ id : 8 } , %{ id : 9 } , %{ id : 10 } , %{ id : 11 } , %{ id : 12 } ] , # Fob.Cursor &lt; ... &gt; }","ref":"Fob.Cursor.html","title":"Fob.Cursor","type":"module"},{"doc":"Creates a new cursor Pass nil as page_breaks to start at the beginning of the data set (ordered by whatever ordering conditions are on the queryable).","ref":"Fob.Cursor.html#new/4","title":"Fob.Cursor.new/4","type":"function"},{"doc":"Fetches the next set of records and returns the next cursor If the underlying table doesn't change, calling next/1 repeatedly will give the same records. The returned cursor can be used to get the next page of records.","ref":"Fob.Cursor.html#next/1","title":"Fob.Cursor.next/1","type":"function"},{"doc":"Fetches count next pages and returns the next cursor For reference: next/1 is implemented as split(cursor, 1) .","ref":"Fob.Cursor.html#split/2","title":"Fob.Cursor.split/2","type":"function"},{"doc":"A data structure representing a position in a data set Cursors are immutable data structures that do not spawn or interact with processes.","ref":"Fob.Cursor.html#t:t/0","title":"Fob.Cursor.t/0","type":"opaque"},{"doc":"Functions and types for operating on page break values","ref":"Fob.PageBreak.html","title":"Fob.PageBreak","type":"module"},{"doc":"Compares two page breaks given the ordering defined in the queryable Returns :eq if the two page breaks are equal, :lt if a is would come before b in the data set when queried, and :gt if b would come before a .","ref":"Fob.PageBreak.html#compare/3","title":"Fob.PageBreak.compare/3","type":"function"},{"doc":"Expands the n-dimensional space occupied by a bound of page-breaks If one holds on to the page-breaks from the start and stop of a dataset (with start being the first record returned and stop being the last record of the most recently requested page; i.e. the cursor), they have the boundaries of the page-break-space for the query . It can be useful to be able to expand this space in the case of row insertions into the database. If an insertion comes in, one must compute its page-break values and compare those to the held start and stop page-break values. This function performs that comparison and returns a tuple of the new start and stop , where proposed could possibly replace the start or stop (or neither).","ref":"Fob.PageBreak.html#expand_space/4","title":"Fob.PageBreak.expand_space/4","type":"function"},{"doc":"A data structure for describing a position within an ordered data set","ref":"Fob.PageBreak.html#t:t/0","title":"Fob.PageBreak.t/0","type":"type"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added order depdendent column metadata tracking. Deprecated Fob.Ordering.columns/1","ref":"changelog.html#1-1-0-2023-07-05","title":"Changelog - 1.1.0 - 2023-07-05","type":"extras"},{"doc":"Fixed Updated dynamic expression creation to work with Ecto 3.9.1 and retain backwards compatibility.","ref":"changelog.html#1-0-3-2022-10-25","title":"Changelog - 1.0.3 - 2022-10-25","type":"extras"},{"doc":"Fixed Fixed issues which caused some select expressions to fail when used with join queries.","ref":"changelog.html#1-0-2-2022-08-11","title":"Changelog - 1.0.2 - 2022-08-11","type":"extras"},{"doc":"Added Added documentation","ref":"changelog.html#1-0-1-2022-05-12","title":"Changelog - 1.0.1 - 2022-05-12","type":"extras"},{"doc":"No changes. This release marks stability in the API.","ref":"changelog.html#1-0-0-2022-05-11","title":"Changelog - 1.0.0 - 2022-05-11","type":"extras"},{"doc":"Addded When ording by a fragment, Fob may now cast dates from binaries into Date structs This fixes errors arising from fetching the next page of data when ordering by a fragment See the new test/fob/fragment_casting_test.exs test cases","ref":"changelog.html#0-7-0-2022-03-16","title":"Changelog - 0.7.0 - 2022-03-16","type":"extras"},{"doc":"Fixed Fixed some cases where date / datetime casting suffered from the dynamic expressions approach. The original Ecto integration queries now run unless a fragment if supplied.","ref":"changelog.html#0-6-1-2022-03-14","title":"Changelog - 0.6.1 - 2022-03-14","type":"extras"},{"doc":"Changed Added the ability to paginate with order by fragments, when the same query fragment is a select. See tests for example.","ref":"changelog.html#0-6-0-2022-03-10","title":"Changelog - 0.6.0 - 2022-03-10","type":"extras"},{"doc":"Fixed Fixed a case where Fob.page_breaks/2 would miscalculate the page breaks when a query was ordered by a column which was also part of a select that belonged to a joined table.","ref":"changelog.html#0-5-1-2022-02-04","title":"Changelog - 0.5.1 - 2022-02-04","type":"extras"},{"doc":"Changed Removed usages of infinity and -infinity postgres fragments This fixes a query error when ordering by a nillable integer-type column","ref":"changelog.html#0-5-0-2021-12-03","title":"Changelog - 0.5.0 - 2021-12-03","type":"extras"},{"doc":"Added Added the ability to paginate by :infinity page size this returns the entire dataset","ref":"changelog.html#0-4-0-2021-03-17","title":"Changelog - 0.4.0 - 2021-03-17","type":"extras"},{"doc":"Fixed Added implementations for Fob.PageBreak.compare/3 and compare/2 for nil s","ref":"changelog.html#0-3-0-2021-03-05","title":"Changelog - 0.3.0 - 2021-03-05","type":"extras"},{"doc":"Added Added a Fob.PageBreak.expand_space/4 function for expanding the bounds of a page-break space.","ref":"changelog.html#0-3-0-2021-03-04","title":"Changelog - 0.3.0 - 2021-03-04","type":"extras"},{"doc":"Added Added Fob.between_bounds/3 for querying any number of records between two page-breaks kind-of a book-ends concept rather than page-breaks :thinking: Added Fob.PageBreak.compare/2 and Fob.PageBreak.compare/3 for comparing lists of page breaks","ref":"changelog.html#0-2-0-2021-03-04","title":"Changelog - 0.2.0 - 2021-03-04","type":"extras"},{"doc":"Added Initial implementation","ref":"changelog.html#0-1-0-2021-03-03","title":"Changelog - 0.1.0 - 2021-03-03","type":"extras"},{"doc":"Added This project was generated by Gaas","ref":"changelog.html#0-0-0-2021-02-25","title":"Changelog - 0.0.0 - 2021-02-25","type":"extras"}]